import domain.AuthUseCaseImpl
import data.models.User
import data.repository.NewUserRepositoryImpl
import data.repository.UserRepository
import data.repository.UserRepositoryImpl
import domain.AuthUseCase
import domain.models.RegistrationRequest

fun main() {
    val repository = UserRepositoryImpl()
    val useCase = AuthUseCaseImpl(repository)


    while (true) {

        println("1.Вывести пользователей\n2.Регистрация пользователя")
        when (readln().toInt()) {
            1  -> printAllUsers(repository)
            2 -> addUser(useCase)
            else -> break
        }
    }

}

fun printAllUsers(userRepository: UserRepository) {
    userRepository.getAllUsers().forEach { user ->
        println("${user.id} ${user.email} ${user.lastName} ${user.firstName}")
    }
}

fun addUser(useCase: AuthUseCase){
    println("Введите почту")
    val email = readln()
    println("Введите Имя Фамилию")
    val firstName = readln()
    println("Введите пароль")
    val password = readln()
    val user = RegistrationRequest(email =  email, name = firstName, password = password)
    useCase.registration(user)
}