package data.repository

import data.models.AddUserRequest
import data.models.User

class UserRepositoryImpl : UserRepository {
    private val _users = mutableListOf<User>(
        User(id = 1, lastName = "Ivanov", firstName = "Ivan", email = "ivan@mai.ru", password = "123"),
        User(id = 2, lastName = "Petrov", firstName = "Petr", email = "petr@mai.ru", password = "123"),
        User(id = 3, lastName = "Alex", firstName = "Alexandrov", email = "Alex@mai.ru", password = "123"),
        User(id = 4, lastName = "Kolya", firstName = "Nikolaev", email = "kolya@mai.ru", password = "123"),
    )

    override fun getAllUsers(): List<User> {
        return _users
    }

    override fun addUser(newUser: AddUserRequest): User
    {
        val user = User(id = _users.count() + 1,
            email = newUser.email,
            lastName = newUser.lastName,
            firstName = newUser.firstName,
            password = newUser.password
        )
        _users.add(user)
        return user
    }

    override fun removeUserById(id: Int): Boolean {
        TODO("Not yet implemented")
    }

    override fun updateUser(id: Int, newUser: User): Boolean {
        val userIndex = _users.indexOfFirst { it -> it.id == id }
        _users[userIndex] = _users[userIndex].copy(
            firstName = newUser.firstName,
            lastName = newUser.lastName,
            email = newUser.email,
            )
        return  true
    }
}